drop sequence co_sys_meta_class_sqid;
create sequence co_sys_meta_class_sqid start 1;

drop table co_sys_meta_class;
create table co_sys_meta_class
(
   id		int 	default nextval('co_usr_meta_class_sqid'),
   deleted 	int 	default 0,
   version 	int 	default 0,
   class_name	text	default '',
   inherits_from	text	default ''
);

grant all on co_sys_meta_class to nobody;

insert into co_sys_meta_class (class_name, inherits_from)
                        values('meta_class', 'generic'  );


drop sequence co_sys_meta_method_sqid;
create sequence co_sys_meta_method_sqid start 1;

drop table co_sys_meta_method;
create table co_sys_meta_method
(
   id			int 	default nextval('co_sys_meta_method_sqid'),
   deleted 		int 	default 0,
   version 		int 	default 0,
   class_name		text	default '',
   method_name		text	default ''
);

grant all on co_sys_meta_method to nobody;

insert into co_sys_meta_class (class_name, inherits_from)
                        values('meta_method', 'generic'  );


insert into co_sys_meta_method (class_name, method_name)
                         values('generic','get');

insert into co_sys_meta_method (class_name, method_name)
                         values('generic','update');

insert into co_sys_meta_method (class_name, method_name)
                         values('generic','select');

insert into co_sys_meta_method (class_name, method_name)
                         values('generic','getSchema');

insert into co_sys_meta_method (class_name, method_name)
                         values('generic','getRelatedClasses');


drop sequence co_sys_meta_prop_sqid;
create sequence co_sys_meta_prop_sqid start 1;

drop table co_sys_meta_prop;
create table co_sys_meta_prop
(
   id			int 	default nextval('co_sys_meta_prop_sqid'),
   deleted 		int 	default 0,
   version 		int 	default 0,
   class_name		text	default '',
   prop_name		text	default '',
   prop_params		text	default '',
   prop_representant 	integer default 0,
   prop_foreign		text	default '',
   prop_foreign_prop	text	default '',
   prop_position 	int	default 0,
   prop_type		text	default 'text'
);

grant all on co_sys_meta_prop to nobody;

/* meta_class */
insert into co_sys_meta_prop (class_name, prop_name, prop_params, prop_representant, prop_foreign, prop_position, prop_type)
                        values('meta_class', 'id'  ,'READONLY=1',1                ,''          , 0        , 'integer');

insert into co_sys_meta_prop (class_name, prop_name, prop_params, prop_representant, prop_foreign, prop_position, prop_type)
                           values('meta_class', 'class_name'  ,''       ,1                ,''          , 100        , 'text');

insert into co_sys_meta_prop (class_name, prop_name, prop_params, prop_representant, prop_foreign, prop_position, prop_type)
                       values('meta_class','inherits_from', ''       ,1                ,''          , 100        , 'text');

/* meta_method */
insert into co_sys_meta_prop (class_name, prop_name, prop_params, prop_representant, prop_foreign, prop_position, prop_type)
                        values('meta_method', 'id'  ,'READONLY=1',1                ,''          , 0        , 'integer');

insert into co_sys_meta_prop (class_name, prop_name, prop_params, prop_representant, prop_foreign, prop_position, prop_type)
                           values('meta_method', 'method_name'  ,''       ,1                ,''          , 100        , 'text');

insert into co_sys_meta_prop (class_name, prop_name, prop_params, prop_representant, prop_foreign, prop_foreign_prop,prop_position, prop_type)
                       values('meta_method','class_name', ''       ,1                ,'meta_class', 'class_name'      , 200        , 'text');


/* meta_prop */
insert into co_sys_meta_class (class_name, inherits_from)
                        values('meta_prop', 'generic'  );


insert into co_sys_meta_prop (class_name, prop_name, prop_params, prop_representant, prop_foreign, prop_position, prop_type)
                        values('meta_prop', 'id'  ,'READONLY=1',1                ,''          , 0        , 'integer');

insert into co_sys_meta_prop (class_name, prop_name, prop_params, prop_representant, prop_foreign, prop_position, prop_type)
                           values('meta_prop', 'prop_name'  ,''       ,1                ,''          , 100        , 'text');

insert into co_sys_meta_prop (class_name, prop_name, prop_params, prop_representant, prop_foreign, prop_foreign_prop,prop_position, prop_type)
                       values('meta_prop','class_name', ''       ,1                ,'meta_class', 'class_name'      , 200        , 'text');

insert into co_sys_meta_prop (class_name, prop_name, prop_params, prop_representant, prop_foreign, prop_position, prop_type)
                       values('meta_prop','prop_params', ''       ,1                ,''          , 300        , 'text');

insert into co_sys_meta_prop (class_name, prop_name, prop_params, prop_representant, prop_foreign, prop_position, prop_type)
                       values('meta_prop','prop_representant', ''  ,1                ,''          , 400        , 'integer');

insert into co_sys_meta_prop (class_name, prop_name, prop_params, prop_representant, prop_foreign, prop_position, prop_type)
                       values('meta_prop','prop_foreign', ''       ,1                ,''          , 500        , 'text');

insert into co_sys_meta_prop (class_name, prop_name, prop_params, prop_representant, prop_foreign, prop_position, prop_type)
                       values('meta_prop','prop_foreign_prop', ''   ,1             ,''          , 550        , 'text');


insert into co_sys_meta_prop (class_name, prop_name, prop_params, prop_representant, prop_foreign, prop_position, prop_type)
                       values('meta_prop','prop_position', ''       ,1                ,''          , 600        , 'integer');

insert into co_sys_meta_prop (class_name, prop_name, prop_params, prop_representant, prop_foreign, prop_position, prop_type)
                       values('meta_prop','prop_type', ''       ,1                ,''          , 700        , 'text');

/* vtable */

drop sequence co_sys_meta_vtable_sqid;
create sequence co_sys_meta_vtable_sqid start 1;

drop table co_sys_meta_vtable;
create table co_sys_meta_vtable
(
   id			int 	default nextval('co_sys_meta_vtable_sqid'),
   deleted 		int 	default 0,
   version 		int 	default 0,
   class_name		text	default '',
   method_name		text	default '',
   target_class_name	text	default ''
);

grant all on co_sys_meta_vtable to nobody;

insert into co_sys_meta_class (class_name, inherits_from)
                        values('meta_vtable', 'generic'  );

insert into co_sys_meta_prop (class_name, prop_name, prop_params, prop_representant, prop_foreign, prop_position, prop_type)
                        values('meta_vtable', 'id'  ,'READONLY=1',1                ,''          , 0        , 'integer');

insert into co_sys_meta_prop (class_name, prop_name, prop_params, prop_representant, prop_foreign, prop_foreign_prop,prop_position, prop_type)
                       values('meta_vtable','class_name', ''       ,1                ,'meta_class', 'class_name'      , 200        , 'text');

insert into co_sys_meta_prop (class_name, prop_name, prop_params, prop_representant, prop_foreign, prop_position, prop_type)
                       values('meta_vtable','method_name', ''       ,1                ,''          , 300        , 'text');

insert into co_sys_meta_prop (class_name, prop_name, prop_params, prop_representant, prop_foreign, prop_position, prop_type)
                       values('meta_vtable','target_class_name', ''  ,1                ,''          , 400        , 'text');

insert into co_sys_meta_vtable(class_name, method_name, target_class_name)
select c.class_name, m.method_name, m.class_name
  from co_sys_meta_method m, co_sys_meta_class c
  where inherits_from = m.class_name;
