
#include "httpd.h"
#include "co_lib.h"

#include "co_generic_2d.h"

void *
coj_generic_2d_new_param( co_context *ctx, const char* method_name)
{
    cou_logError( ctx, CO_LOG_DEBUG, "coj_generic_2d_new_param: called for %s", method_name);


    if (strcmp(method_name, "check_acl2d")==0) {
        cou_logError( ctx, CO_LOG_DEBUG, "allocating param struct for check_acl2d");
        return ap_palloc( ctx->request->pool, sizeof(co_typein_check_acl2d) );
    }


    if (strcmp(method_name, "get2D")==0) {
        cou_logError( ctx, CO_LOG_DEBUG, "allocating param struct for get2D");
        return ap_palloc( ctx->request->pool, sizeof(co_typein_get2D) );
    }


    if (strcmp(method_name, "getByProp2D")==0) {
        cou_logError( ctx, CO_LOG_DEBUG, "allocating param struct for getByProp2D");
        return ap_palloc( ctx->request->pool, sizeof(co_typein_getByProp2D) );
    }


    if (strcmp(method_name, "update2D")==0) {
        cou_logError( ctx, CO_LOG_DEBUG, "allocating param struct for update2D");
        return ap_palloc( ctx->request->pool, sizeof(co_typein_update2D) );
    }


    if (strcmp(method_name, "insertChild2D")==0) {
        cou_logError( ctx, CO_LOG_DEBUG, "allocating param struct for insertChild2D");
        return ap_palloc( ctx->request->pool, sizeof(co_typein_insertChild2D) );
    }


    if (strcmp(method_name, "select2D")==0) {
        cou_logError( ctx, CO_LOG_DEBUG, "allocating param struct for select2D");
        return ap_palloc( ctx->request->pool, sizeof(co_typein_select2D) );
    }


    if (strcmp(method_name, "getRelatedClasses2D")==0) {
        cou_logError( ctx, CO_LOG_DEBUG, "allocating param struct for getRelatedClasses2D");
        return ap_palloc( ctx->request->pool, sizeof(co_typein_getRelatedClasses2D) );
    }


    if (strcmp(method_name, "getRelatedData2D")==0) {
        cou_logError( ctx, CO_LOG_DEBUG, "allocating param struct for getRelatedData2D");
        return ap_palloc( ctx->request->pool, sizeof(co_typein_getRelatedData2D) );
    }


    if (strcmp(method_name, "getSchema2D")==0) {
        cou_logError( ctx, CO_LOG_DEBUG, "allocating param struct for getSchema2D");
        return ap_palloc( ctx->request->pool, sizeof(co_typein_getSchema2D) );
    }


    if (strcmp(method_name, "getWithSchema2D")==0) {
        cou_logError( ctx, CO_LOG_DEBUG, "allocating param struct for getWithSchema2D");
        return ap_palloc( ctx->request->pool, sizeof(co_typein_getWithSchema2D) );
    }


    if (strcmp(method_name, "getSchemaRelatedAndData2D")==0) {
        cou_logError( ctx, CO_LOG_DEBUG, "allocating param struct for getSchemaRelatedAndData2D");
        return ap_palloc( ctx->request->pool, sizeof(co_typein_getSchemaRelatedAndData2D) );
    }


    if (strcmp(method_name, "getForRelatedSchemaAndData2D")==0) {
        cou_logError( ctx, CO_LOG_DEBUG, "allocating param struct for getForRelatedSchemaAndData2D");
        return ap_palloc( ctx->request->pool, sizeof(co_typein_getForRelatedSchemaAndData2D) );
    }


    if (strcmp(method_name, "showForm2D")==0) {
        cou_logError( ctx, CO_LOG_DEBUG, "allocating param struct for showForm2D");
        return ap_palloc( ctx->request->pool, sizeof(co_typein_showForm2D) );
    }


    if (strcmp(method_name, "showFormFind2D")==0) {
        cou_logError( ctx, CO_LOG_DEBUG, "allocating param struct for showFormFind2D");
        return ap_palloc( ctx->request->pool, sizeof(co_typein_showFormFind2D) );
    }


    return NULL;
}

int
coj_generic_2d_set_param( co_context *ctx, void *ph,
        const char* method_name, const char *param_name, void *param_value)
{
    int err=0;
    cou_logError( ctx, CO_LOG_DEBUG, "coj_generic_2d_set_param: called");


    if (strcmp(method_name, "check_acl2d")==0) {

	co_typein_check_acl2d *p;
        p = (co_typein_check_acl2d*)ph;

        if (strcmp(param_name, "par_area")==0) {
            p->par_area = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_class")==0) {
            p->par_class = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id1")==0) {
            p->par_id1 = *(int*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id2")==0) {
            p->par_id2 = *(int*)(param_value) ;
	    return err;
	}     
     
    }

    if (strcmp(method_name, "get2D")==0) {

	co_typein_get2D *p;
        p = (co_typein_get2D*)ph;

        if (strcmp(param_name, "par_area")==0) {
            p->par_area = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_class")==0) {
            p->par_class = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id1")==0) {
            p->par_id1 = *(int*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id2")==0) {
            p->par_id2 = *(int*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "callback")==0) {
            p->callback = (char*)(param_value) ;
	    return err;
	}     
     
    }

    if (strcmp(method_name, "getByProp2D")==0) {

	co_typein_getByProp2D *p;
        p = (co_typein_getByProp2D*)ph;

        if (strcmp(param_name, "par_area")==0) {
            p->par_area = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_class")==0) {
            p->par_class = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id1")==0) {
            p->par_id1 = *(int*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id2")==0) {
            p->par_id2 = *(int*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "callback")==0) {
            p->callback = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "prop_name")==0) {
            p->prop_name = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "prop_val")==0) {
            p->prop_val = (char*)(param_value) ;
	    return err;
	}     
     
    }

    if (strcmp(method_name, "update2D")==0) {

	co_typein_update2D *p;
        p = (co_typein_update2D*)ph;

        if (strcmp(param_name, "par_area")==0) {
            p->par_area = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_class")==0) {
            p->par_class = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id1")==0) {
            p->par_id1 = *(int*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id2")==0) {
            p->par_id2 = *(int*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_prop")==0) {
            p->par_prop = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "new_value")==0) {
            p->new_value = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "version")==0) {
            p->version = *(int*)(param_value) ;
	    return err;
	}     
     
    }

    if (strcmp(method_name, "insertChild2D")==0) {

	co_typein_insertChild2D *p;
        p = (co_typein_insertChild2D*)ph;

        if (strcmp(param_name, "par_area")==0) {
            p->par_area = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_class")==0) {
            p->par_class = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id1")==0) {
            p->par_id1 = *(int*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id2")==0) {
            p->par_id2 = *(int*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "child_class")==0) {
            p->child_class = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "child_prop")==0) {
            p->child_prop = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "foreign_prop")==0) {
            p->foreign_prop = (char*)(param_value) ;
	    return err;
	}     
     
    }

    if (strcmp(method_name, "select2D")==0) {

	co_typein_select2D *p;
        p = (co_typein_select2D*)ph;

        if (strcmp(param_name, "par_area")==0) {
            p->par_area = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_class")==0) {
            p->par_class = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id1")==0) {
            p->par_id1 = *(int*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id2")==0) {
            p->par_id2 = *(int*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "callback")==0) {
            p->callback = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "get_class_names")==0) {
            p->get_class_names = (char**)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "get_prop_names")==0) {
            p->get_prop_names = (char**)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "filter_class_names")==0) {
            p->filter_class_names = (char**)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "filter_prop_names")==0) {
            p->filter_prop_names = (char**)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "filter_operators")==0) {
            p->filter_operators = (char**)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "filter_values")==0) {
            p->filter_values = (char**)(param_value) ;
	    return err;
	}     
     
    }

    if (strcmp(method_name, "getRelatedClasses2D")==0) {

	co_typein_getRelatedClasses2D *p;
        p = (co_typein_getRelatedClasses2D*)ph;

        if (strcmp(param_name, "par_area")==0) {
            p->par_area = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_class")==0) {
            p->par_class = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id1")==0) {
            p->par_id1 = *(int*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id2")==0) {
            p->par_id2 = *(int*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "callback")==0) {
            p->callback = (char*)(param_value) ;
	    return err;
	}     
     
    }

    if (strcmp(method_name, "getRelatedData2D")==0) {

	co_typein_getRelatedData2D *p;
        p = (co_typein_getRelatedData2D*)ph;

        if (strcmp(param_name, "par_area")==0) {
            p->par_area = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_class")==0) {
            p->par_class = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id1")==0) {
            p->par_id1 = *(int*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id2")==0) {
            p->par_id2 = *(int*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "callback")==0) {
            p->callback = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "related_class")==0) {
            p->related_class = (char*)(param_value) ;
	    return err;
	}     
     
    }

    if (strcmp(method_name, "getSchema2D")==0) {

	co_typein_getSchema2D *p;
        p = (co_typein_getSchema2D*)ph;

        if (strcmp(param_name, "par_area")==0) {
            p->par_area = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_class")==0) {
            p->par_class = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id1")==0) {
            p->par_id1 = *(int*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id2")==0) {
            p->par_id2 = *(int*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "callback")==0) {
            p->callback = (char*)(param_value) ;
	    return err;
	}     
     
    }

    if (strcmp(method_name, "getWithSchema2D")==0) {

	co_typein_getWithSchema2D *p;
        p = (co_typein_getWithSchema2D*)ph;

        if (strcmp(param_name, "par_area")==0) {
            p->par_area = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_class")==0) {
            p->par_class = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id1")==0) {
            p->par_id1 = *(int*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id2")==0) {
            p->par_id2 = *(int*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "callbacks")==0) {
            p->callbacks = (char**)(param_value) ;
	    return err;
	}     
     
    }

    if (strcmp(method_name, "getSchemaRelatedAndData2D")==0) {

	co_typein_getSchemaRelatedAndData2D *p;
        p = (co_typein_getSchemaRelatedAndData2D*)ph;

        if (strcmp(param_name, "par_area")==0) {
            p->par_area = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_class")==0) {
            p->par_class = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id1")==0) {
            p->par_id1 = *(int*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id2")==0) {
            p->par_id2 = *(int*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "callbacks")==0) {
            p->callbacks = (char**)(param_value) ;
	    return err;
	}     
     
    }

    if (strcmp(method_name, "getForRelatedSchemaAndData2D")==0) {

	co_typein_getForRelatedSchemaAndData2D *p;
        p = (co_typein_getForRelatedSchemaAndData2D*)ph;

        if (strcmp(param_name, "par_area")==0) {
            p->par_area = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_class")==0) {
            p->par_class = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id1")==0) {
            p->par_id1 = *(int*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id2")==0) {
            p->par_id2 = *(int*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "related_class")==0) {
            p->related_class = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "callbacks")==0) {
            p->callbacks = (char**)(param_value) ;
	    return err;
	}     
     
    }

    if (strcmp(method_name, "showForm2D")==0) {

	co_typein_showForm2D *p;
        p = (co_typein_showForm2D*)ph;

        if (strcmp(param_name, "par_area")==0) {
            p->par_area = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_class")==0) {
            p->par_class = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id1")==0) {
            p->par_id1 = *(int*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id2")==0) {
            p->par_id2 = *(int*)(param_value) ;
	    return err;
	}     
     
    }

    if (strcmp(method_name, "showFormFind2D")==0) {

	co_typein_showFormFind2D *p;
        p = (co_typein_showFormFind2D*)ph;

        if (strcmp(param_name, "par_area")==0) {
            p->par_area = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_class")==0) {
            p->par_class = (char*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id1")==0) {
            p->par_id1 = *(int*)(param_value) ;
	    return err;
	}     
     

        if (strcmp(param_name, "par_id2")==0) {
            p->par_id2 = *(int*)(param_value) ;
	    return err;
	}     
     
    }

    return -1; /* param not found */
}

     // JavaScript interface to methods of class 
     
