#!/usr/bin/perl
######################### We start with some black magic to print on failure.
BEGIN { $| = 1; }
END {print "test failed \n" unless \$loaded;}
use Pg;
$loaded = 1;
use strict;
######################### End of black magic.
##my $dbmain = 'nobody';
##my $dbname = 'nobody';
my $dbconnstr = 'dbname=nobody';
my $trace  = '/tmp/pgtrace.out';
my ($conn, $result, $i, $last_id);
my $DEBUG  = 0; # set this to 1 for traces
$SIG{PIPE} = sub { print "broken pipe \n" };
if ($#ARGV ne -1) { $dbconnstr = $ARGV[0]; shift; }
######################### create and connect to database
my $Option_ref = Pg::conndefaults();
my ($key, $val);
( $$Option_ref{port} ne "" && $$Option_ref{dbname} ne "" && $$Option_ref{user} ne "" )
and print "Pg::conndefaults ........ ok \n"
or  die   "Pg::conndefaults ........ not ok: ", $conn->errorMessage;
sub sql_exe
{
   my($conn, $sql) = @_;
   my($ret) = $conn->exec($sql); # || die "ERROR in executing $sql \n" ;
   if(PGRES_COMMAND_OK ne $ret->resultStatus) 
   {
      $!=-1; 
      die "SQL: ".$sql." ".$conn->errorMessage;
   }
   return $ret;
}

sub sql_sel
{
   my($conn, $sql) = @_;
   my($ret) = $conn->exec($sql); # || die "ERROR in executing $sql \n" ;
   if(PGRES_TUPLES_OK ne $ret->resultStatus)
   {
       $!=-1; 
       die "SQL: ".$sql." ".$conn->errorMessage;
   }  
   return $ret;
}

my(@parents);

$conn = Pg::connectdb($dbconnstr);
( PGRES_CONNECTION_OK eq $conn->status )
    and print "Pg::connectdb ........... ok \n"
    or  die   "Pg::connectdb ........... not ok: ", $conn->errorMessage;  

my($default_area) = "sys";
my($system_area) = "sys";

###########################################################################################
#AREA.CLASS sys.menu 
#REMOVE OLD
$result = sql_exe($conn, "DELETE FROM co_sys_acl WHERE id_object IN (SELECT id FROM co_sys_menu WHERE name='associations#multi\@generic_association') 
                                            AND class_name = 'menu' AND area='sys'");
$result = sql_exe($conn, "DELETE FROM co_sys_menu WHERE name='associations#multi\@generic_association'"); 
$result = sql_exe($conn, " INSERT INTO co_sys_menu (deleted  , name , id_parent , class_name) 
SELECT 0 , 'associations#multi\\\@generic_association' , (SELECT id FROM co_sys_menu WHERE name = 'root') , 'generic_association' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_sqid");
            	      $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sys_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sys_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu'");
				 sql_exe($conn, "INSERT INTO co_sys_acl
                                 SELECT NEXTVAL('co_sys_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sys_permission p, co_sys_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sys_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sys_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu'");
				 sql_exe($conn, "INSERT INTO co_sys_acl
                                 SELECT NEXTVAL('co_sys_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sys_permission p, co_sys_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.js_code 
$result = sql_exe($conn, " INSERT INTO co_sys_js_code (deleted  , code) 
SELECT 0 , 'var current_class = eval(\\\"new class_\\\"+context.active_class+\\\"(\\\'\\\"+COServer.getAreaName()+\\\"\\\')\\\");
COServer.beginJSCreation();
current_class.EXT_insertAssociations({
  par_id: -1,
  callback: \\\"parent.showReturned(\\\",
  prop_first_class: context.column_first_class,
  ids_first_class: context.ids_first_class.split(\\\"\\\|\\\"),
  prop_second_class: context.column_second_class,
  ids_second_class: context.ids_second_class.split(\\\"\\\|\\\")
});
COServer.endJSCreation();
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_js_code_sqid");
            	      $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sys_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sys_role r WHERE r.name='root')
				 AND area='sys' AND class_name='js_code'");
				 sql_exe($conn, "INSERT INTO co_sys_acl
                                 SELECT NEXTVAL('co_sys_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_code'
                                 FROM  co_sys_permission p, co_sys_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sys_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sys_role r WHERE r.name='user')
				 AND area='sys' AND class_name='js_code'");
				 sql_exe($conn, "INSERT INTO co_sys_acl
                                 SELECT NEXTVAL('co_sys_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_code'
                                 FROM  co_sys_permission p, co_sys_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action 
#REMOVE OLD
$result = sql_exe($conn, "DELETE FROM co_sys_acl WHERE id_object IN (SELECT id FROM co_sys_menu_action WHERE name='generic_multi_create_associations') 
                                            AND class_name = 'menu_action' AND area='sys'");
$result = sql_exe($conn, "DELETE FROM co_sys_menu_action WHERE name='generic_multi_create_associations'"); 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'generic_multi_create_associations' , (SELECT last_value FROM co_sys_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_sqid");
            	      $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sys_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sys_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action'");
				 sql_exe($conn, "INSERT INTO co_sys_acl
                                 SELECT NEXTVAL('co_sys_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action'
                                 FROM  co_sys_permission p, co_sys_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sys_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sys_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action'");
				 sql_exe($conn, "INSERT INTO co_sys_acl
                                 SELECT NEXTVAL('co_sys_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action'
                                 FROM  co_sys_permission p, co_sys_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
            	      $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sys_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sys_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param'");
				 sql_exe($conn, "INSERT INTO co_sys_acl
                                 SELECT NEXTVAL('co_sys_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sys_permission p, co_sys_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sys_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sys_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param'");
				 sql_exe($conn, "INSERT INTO co_sys_acl
                                 SELECT NEXTVAL('co_sys_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sys_permission p, co_sys_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'column_first_class' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
            	      $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sys_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sys_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param'");
				 sql_exe($conn, "INSERT INTO co_sys_acl
                                 SELECT NEXTVAL('co_sys_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sys_permission p, co_sys_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sys_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sys_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param'");
				 sql_exe($conn, "INSERT INTO co_sys_acl
                                 SELECT NEXTVAL('co_sys_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sys_permission p, co_sys_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'ids_first_class' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
            	      $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sys_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sys_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param'");
				 sql_exe($conn, "INSERT INTO co_sys_acl
                                 SELECT NEXTVAL('co_sys_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sys_permission p, co_sys_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sys_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sys_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param'");
				 sql_exe($conn, "INSERT INTO co_sys_acl
                                 SELECT NEXTVAL('co_sys_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sys_permission p, co_sys_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'column_second_class' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
            	      $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sys_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sys_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param'");
				 sql_exe($conn, "INSERT INTO co_sys_acl
                                 SELECT NEXTVAL('co_sys_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sys_permission p, co_sys_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sys_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sys_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param'");
				 sql_exe($conn, "INSERT INTO co_sys_acl
                                 SELECT NEXTVAL('co_sys_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sys_permission p, co_sys_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'ids_second_class' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
            	      $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sys_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sys_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param'");
				 sql_exe($conn, "INSERT INTO co_sys_acl
                                 SELECT NEXTVAL('co_sys_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sys_permission p, co_sys_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sys_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sys_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param'");
				 sql_exe($conn, "INSERT INTO co_sys_acl
                                 SELECT NEXTVAL('co_sys_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sys_permission p, co_sys_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu 
#REMOVE OLD
$result = sql_exe($conn, "DELETE FROM co_sys_acl WHERE id_object IN (SELECT id FROM co_sys_menu WHERE name='multi_create_associations') 
                                            AND class_name = 'menu' AND area='sys'");
$result = sql_exe($conn, "DELETE FROM co_sys_menu WHERE name='multi_create_associations'"); 
$result = sql_exe($conn, " INSERT INTO co_sys_menu (deleted  , name , display_name , class_name , id_parent , id_menu_action , id_permission , menu_position , sec_type) 
SELECT 0 , 'multi_create_associations' , 'Nowe asocjacje' , 'generic_association' , (SELECT id FROM co_sys_menu WHERE name = 'associations#multi\\\@generic_association') , (SELECT last_value FROM co_sys_menu_action_sqid) , '10' , '200' , '1' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_sqid");
            	      $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sys_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sys_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu'");
				 sql_exe($conn, "INSERT INTO co_sys_acl
                                 SELECT NEXTVAL('co_sys_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sys_permission p, co_sys_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sys_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sys_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu'");
				 sql_exe($conn, "INSERT INTO co_sys_acl
                                 SELECT NEXTVAL('co_sys_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sys_permission p, co_sys_role r
				 WHERE r.name= 'user'
				 ");
                         