#include "init_file_names.t"
#include "defines.t"

file __INIT_JS_LIB()
{

class js_lib
{
  area sys;
  full_control root;
  remove_old "name='root'";
  p name {val 'root';};
  p id_catalog_type {getByProp catalog_type {prop class_name{val js_lib;};};};
  p id_parent {val 0;};
  p id_user {getByNameInArea user {f System; area 'sys';};};
  p id_item {current_id 1;};
};

// ASP TOOLS
class js_lib
{
	area sys;

	full_control root;
	full_control __PUBLIC__;

	remove_old "name='asp_tools'";
	p name {val 'asp_tools';};
	p id_parent {getByName js_lib {f root;};};
	p id_catalog_type {getByProp catalog_type {prop class_name{val js_lib;};};};
	p id_user {getByNameInArea user {f System; area 'sys';};};
	p id_item {current_id 1;};

	// asp_eval_string_condition
	class js_code
	{
		area sys;

		full_control root;
		full_control __PUBLIC__;

		p code { val 
		%%
function safe_eval(str)
{
  return eval(str);
}

function eval_string_conditions(rs, str, pos, tuple_num)
{
   var pos_if = pos;
   var pos_if_end = pos_if + 7;  
   var pos_then = str.indexOf("<#?THEN#>", pos_if_end);
   if(pos_then == -1) 
         return "BAD STRING: NO <#?THEN#> AFTER <#?IF#>: " 
                + web_encode(str.substr(pos_if));
   var pos_then_end = pos_then + 9;
  
   var pos_endif = str.indexOf("<#?ENDIF#>", pos_then_end);
   if(pos_endif == -1) 
         return "BAD STRING: NO <#?ENDIF#> AFTER <#?IF#>: " 
                 + web_encode(str.substr(pos_if));
   var pos_endif_end = pos_endif + 10;

   var condition = str.substr(pos_if_end, pos_then - pos_if_end);
   condition = rs.printTupleExt(null,condition, tuple_num);
      
   if(safe_eval(condition))
   {
      var cond_text = str.substr(pos_then_end, pos_endif-pos_then_end);
      str = str.substr(0, pos_if) + cond_text + str.substr(pos_endif_end);
   }
   else
   {
      str = str.substr(0, pos_if) + str.substr(pos_endif_end);
   }
     
   return str;
};
		%%
		;
		};
	};

	class js_lib
	{
		area sys;

		full_control root;
		full_control __PUBLIC__;

		remove_old "name='asp_eval_string_condition'";
		p name {val 'asp_eval_string_condition';};
		p id_parent {getByName js_lib {f asp_tools;};};
		p id_catalog_type {getByProp catalog_type {prop class_name{val js_code;};};};
		p id_user {getByNameInArea user {f System; area 'sys';};};
		p id_item {recent js_code;};
	};

	// asp_eval_field
	class js_code
	{
		area sys;

		full_control root;
		full_control __PUBLIC__;

		p code 	{ val 
		%%
function eval_string_field(rs, str, pos_org, tuple_num)
{
   var pos = pos_org;
   var start_pos = pos;

   if(str.charAt(pos+2)==":")
   {
     var no_enc = true;
     pos+=3;
     var end_tag = ":#>";
   }
   else
   {
     var no_enc = false;
     pos+=2;
     var end_tag = "#>";
   }
   var pos_end = str.indexOf(end_tag, pos);
   if(pos_end == -1) 
   {
       return "BAD STRING: NO " + end_tag + " AFTER <# : " + web_encode(str.substr(pos));
   }
   var field_name = str.substr(pos, pos_end-pos);
   try
   {
      var f_value = rs.getValueByName(tuple_num, field_name);
      var end_pos = pos_end + end_tag.length;
      if(no_enc)
      {
         str = str.substr(0, start_pos) + f_value + str.substr(end_pos);
      }
      else
      {
         str = str.substr(0, start_pos) + web_encode(f_value) + str.substr(end_pos);
      }

   }catch(e){};
    
   return str;
};
		%%
		;
		};
	};

	class js_lib
	{
		area sys;

		full_control root;
		full_control __PUBLIC__;

		remove_old "name='asp_eval_field'";
		p name {val 'asp_eval_field';};
		p id_parent {getByName js_lib {f asp_tools;};};
		p id_catalog_type {getByProp catalog_type {prop class_name{val js_code;};};};
		p id_user {getByNameInArea user {f System; area 'sys';};};
		p id_item {recent js_code;};
	};

	//  asp_eval_related
	class js_code
	{
		area sys;

		full_control root;
		full_control __PUBLIC__;

		p code 	{ val 
		%%
function eval_string_related(rs, str, pos, tuple_num, obj)
{
   var tag_start="<#&RELATED#>";
   var tag_middle="<#&FOREACH#>";
   var tag_end="<#&ENDRELATED#>";


   if(str.indexOf(tag_start,pos)!= pos)
     return "BAD STRING: NO " + web_encode(tag_start) + ": " 
                + web_encode(str.substr(pos_start));


   var pos_start = pos;
   var pos_start_end = pos_start + tag_start.length;
   var pos_middle = str.indexOf(tag_middle, pos_start);
   if(pos_middle == -1) 
         return "BAD STRING: NO " + tag_middle + " AFTER " + tag_start + ": " 
                + web_encode(str.substr(pos_start));
   var pos_middle_end = pos_middle + tag_middle.length;
  
   var pos_end = str.indexOf(tag_end, pos_middle_end);
   if(pos_end == -1) 
         return "BAD STRING: NO " + tag_end + " AFTER " + tag_start + ": " 
                + web_encode(str.substr(pos_start));
   var pos_end_end = pos_end + tag_end.length;

   var arrRelNamProp = (str.substr(pos_start_end, pos_middle - pos_start_end)).split("|");
   
   var curr_id = Number(rs.getValueByName(tuple_num, "id"));

   var params = { par_id : curr_id,
                  par_class : obj.strClass ,
                  related_class : arrRelNamProp[0],
                  related_prop  : arrRelNamProp[1]
                }
   if(arrRelNamProp.length>2) params.dynamic_prop = arrRelNamProp[2];
   var rs_rel = obj.EXT_getRelatedData(params);
   var rel_template = str.substr(pos_middle_end, pos_end - pos_middle_end);
   var str_related = rs_rel.printExt(obj, rel_template);
   str = str.substr(0, pos_start) + str_related + str.substr(pos_end_end);

   return str;
};
		%%
		;
		};
	};

	class js_lib
	{
		area sys;

		full_control root;
		full_control __PUBLIC__;

		remove_old "name='asp_eval_related'";
		p name {val 'asp_eval_related';};
		p id_parent {getByName js_lib {f asp_tools;};};
		p id_catalog_type {getByProp catalog_type {prop class_name{val js_code;};};};
		p id_user {getByNameInArea user {f System; area 'sys';};};
		p id_item {recent js_code;};
	};

	// asp_web_encode
	class js_code
	{
		area sys;

		full_control root;
		full_control __PUBLIC__;

		p code 	{ val 
		%%
  function web_encode(str)
  {
     var re = /</g;
     var ret = str.replace(re, "&lt;");
     re = />/g;
     ret = ret.replace(re, "&gt;");
     re = / /g;
     ret = ret.replace(re, "&nbsp;");
     re = /\\n/g;
     ret = ret.replace(re, "<BR>");
 
     return ret;
  }
		%%
		;
		};
	};

	class js_lib
	{
		area sys;

		full_control root;
		full_control __PUBLIC__;

		remove_old "name='asp_web_encode'";
		p name {val 'asp_web_encode';};
		p id_parent {getByName js_lib {f asp_tools;};};
		p id_catalog_type {getByProp catalog_type {prop class_name{val js_code;};};};
		p id_user {getByNameInArea user {f System; area 'sys';};};
		p id_item {recent js_code;};
	};

	// asp_recordset_print
	class js_code
	{
		area sys;

		full_control root;
		full_control __PUBLIC__;

		p code 	{ val 
		%%
function recordset_print(template, alt_template)
{
  return this.printExt(null, template, alt_template);
}
  
function recordset_printExt(obj, template, alt_template)
{
    var NTuples = this.getTupleCount();
    var ret = "";
    if(alt_template!=null)
    {
      var odd = 0;
      for(var i=0; i<NTuples; i++)
      {
        if(odd==0)
        {
           ret+= this.printTupleExt(obj,template, i);
           odd=1;
        }
        else
        {
           ret+= this.printTupleExt(obj,alt_template, i);
           odd=0;
        }
 
      }
    }
    else
    {
      for(var i=0; i<NTuples; i++)
      {
        ret+= this.printTupleExt(obj,template, i);
      }
    }
    return ret;
}
 
Recordset.prototype.print = recordset_print;
Recordset.prototype.printExt = recordset_printExt;
		%%
		;
		};
	};

	class js_lib
	{
		area sys;

		full_control root;
		full_control __PUBLIC__;

		remove_old "name='asp_recordset_print'";
		p name {val 'asp_recordset_print';};
		p id_parent {getByName js_lib {f asp_tools;};};
		p id_catalog_type {getByProp catalog_type {prop class_name{val js_code;};};};
		p id_user {getByNameInArea user {f System; area 'sys';};};
		p id_item {recent js_code;};
	};

	// asp_recordset_printTuple
	class js_code
	{
		area sys;

		full_control root;
		full_control __PUBLIC__;

		p code 	{ val 
		%%
function recordset_printTuple(obj, template, tuple_num)
{
  return this.printTupleExt(null, template, tuple_num);
}

function recordset_printTupleExt(obj, template, tuple_num)
{
    var tag = "<#";
    var pos = 0;
    while(pos != -1)
    {
         pos = template.indexOf(tag, pos);
         if(pos == -1) break;
         if(template.charAt(pos+2)== "?")
         {
            template = eval_string_conditions(this, template, pos, tuple_num)
         }
         else if(template.charAt(pos+2) == "&")
         {
            template = eval_string_related(this, template, pos, tuple_num, obj)
         }
         else
         {
            template = eval_string_field(this, template, pos, tuple_num);
         } 
     } 
    return template;
}
  
Recordset.prototype.printTuple = recordset_printTuple;
Recordset.prototype.printTupleExt = recordset_printTupleExt;
		%%
		;
		};
	};

	class js_lib
	{
		area sys;

		full_control root;
		full_control __PUBLIC__;

		remove_old "name='asp_recordset_printTuple'";
		p name {val 'asp_recordset_printTuple';};
		p id_parent {getByName js_lib {f asp_tools;};};
		p id_catalog_type {getByProp catalog_type {prop class_name{val js_code;};};};
		p id_user {getByNameInArea user {f System; area 'sys';};};
		p id_item {recent js_code;};
	};
}; // asp_tools

// asp_reuse
class js_code
{
	area sys;

	full_control root;
	full_control __PUBLIC__;

	p code { val 
	%%
function useASP(sArea, sPath, sArgs) {
  var catalog = new class_catalog(sArea);
  var nCatalogId = catalog.getIdByPath(-1, 1, sPath);
  var nAspId = catalog.getProp( nCatalogId, 'id_item' );
  var text_document = new class_text_document(sArea);
  text_document.evalTextDocumentAsASP( nAspId, '&'+sArgs );
}
	%%
	;
	};
};

class js_lib
{
	area sys;

	full_control root;
	full_control __PUBLIC__;

	remove_old "name='asp_reuse'";
	p name {val 'asp_reuse';};
	p id_parent {getByName js_lib {f root;};};
	p id_catalog_type {getByProp catalog_type {prop class_name{val js_code;};};};
	p id_user {getByNameInArea user {f System; area 'sys';};};
	p id_item {recent js_code;};
};
// END OF ASP TOOLS


class js_code
{
  area sys;

  full_control "root";
  p code {val
   %%

    function client_execute(strFunctionName)
    {
        var args = client_execute.arguments;
        var i=0;

        ap_write(strFunctionName);
        ap_write("(");
        if (args.length>1) {
            for (i=1; i<args.length; i++) {
                if (i!=1) ap_write(",'");
                else ap_write("'");
                ap_write(args[i].toString().replace( new RegExp("'","g"), "\\'"));
                ap_write("'");
            }
        }
        ap_write(");");
    }

    /* for class par_class being the real thing to open */
    function openDefaultForm(par_area, type_class_name, par_id)
    {

        if (type_class_name!="attachment")
        {
         // we take default form for items class
         var meta = new class_meta_class(par_area);
         var default_form = meta.getDefaultFormByName( -1 , type_class_name);

         // we ask to open window with default form
         client_execute("open_url",
            "/co/html/" + par_area+ "/" + type_class_name+"?" + default_form +
                 "&par_area="+ par_area +
                 "&par_class="+ type_class_name+
                 "&par_id="+par_id+
                 "&debug_level=0" );
        }
    }


    /* for class par_class being catalog-type wrapper */
    function openCatalogItem(par_area, par_class, par_id)
    {
        // we read items data: what item type is wrapped here?
        var cat = eval("new class_" + par_class + "('" + par_area + "');");
        var rs =  cat.getItemData( par_id );
        var type_class_name = rs.getValueByName(0, "type_class_name");

        openDefaultForm(par_area, type_class_name, rs.getValueByName(0,"id_item"));
    }

	/* just a shortcut for calling client alert function */
    function alert(strMsg) 
	{
		client_execute("alert", strMsg);
	};

   %%
   ;
   };
};

class js_lib
{
	area sys;

	full_control "root";
	remove_old "name='client'";
	p name {val 'client';};
	p id_parent {getByName js_lib {f root;};};
	p id_catalog_type {getByProp catalog_type {prop class_name{val js_code;};};};
	p id_user {getByNameInArea user {f System; area 'sys';};};
	p id_item {recent js_code;};
};

class js_code
{
  area sys;

  full_control "root";
  p code {val
   %%

function formatDate(d)
{
  var month = (d.getMonth()+1);
  var day = d.getDate();
  var str = ""+d.getFullYear()+"-";
  if (month<10) str += "0";
  str += month + "-";
  if (day<10) str += "0";
  str += day;
  return str;
}

   %%
   ;
   };
};

class js_lib
{
	area sys;

	full_control "root";
	remove_old "name='format_date'";
	p name {val 'format_date';};
	p id_parent {getByName js_lib {f root;};};
	p id_catalog_type {getByProp catalog_type {prop class_name{val js_code;};};};
	p id_user {getByNameInArea user {f System; area 'sys';};};
	p id_item {recent js_code;};
};

    class catalog_root
    {
        area sys;

          remove_old "class_name='js_lib'";
          p class_name {val js_lib;};
          p id_role {getByNameInArea role {f 'root'; area 'sys';};};
          p id_root {getByName js_lib {f root;};};
          p root_name {val root;};
     };


}; //file
