#include "types.t"
#include "defines.t"

#define __PARAMS_HEADER2 __PARAMS_HEADER
    
class meta_method
{
   area sys
   {
       force_sec_type 1;
   };

#include "check_acl.t"
   
   container_class 'meta_class';
   container_column_name 'class_name';

#include "generic_acl_props.t" 
 
   inherits generic_acl;
 
#if 0

   prop class_name
   {
     type CO_STRING;
     default "''";
     params '';
     representant 1;
     foreign 'meta_class';
     foreign_prop 'class_name';
     position 200;
   };
   
#endif

   prop id_meta_class
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 1;
     foreign 'meta_class';
     foreign_prop 'id';
     position 200;
   };

   prop method_name
   {
     type CO_STRING;
     default "''";
     params '';
     representant 100;
     foreign '';
     foreign_prop '';
     position 300;
   };
 
   prop state
   {
     type CO_STRING;
     default "'NEW'";
     params '';
     representant 0;
     foreign '';
     foreign_prop '';
     position 400;
     group_path '';
   };
 
  
   prop id_permission
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign 'permission';
     foreign_prop 'id';
     position 500;
   };
                  
   prop id_onbefore_script
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign 'js_code';
     foreign_prop 'id';
     position 600;
   };

   prop id_onbefore_method
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign 'meta_method';
     foreign_prop 'id';
     position 700;
   };

   prop id_script
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign 'js_code';
     foreign_prop 'id';
     position 750;
   };

   prop id_onafter_script
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign 'js_code';
     foreign_prop 'id';
     position 800;
   };

   prop id_onafter_method
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign 'meta_method';
     foreign_prop 'id';
     position 900;
   };

   prop profiled
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign '';
     foreign_prop '';
     position 1000;
   };

   prop sec_type
   {
     type CO_INTEGER;
     default 0;
     params 'VALUES=new Array(0,1);';
     representant 0;
     foreign '';
     foreign_prop '';
     position 1100;
   };

 
   prop force_sec_type
   {
     type CO_INTEGER;
     default 0;
     params 'VALUES=new Array(0,1);';
     representant 0;
     foreign '';
     foreign_prop '';
     position 1220;
   };

	prop name
	{
  f_body
  %%
     SELECT method_name($1);
  %%
  ;
		type CO_STRING;
		default "'NEW'";
		params '';
		representant 0;
		foreign '';
		foreign_prop '';
		position 400;
		group_path '';
   };
 

   index in1
   {
    unique 0;
    column id_meta_class;
    column method_name;
    column state;
   };


	uses generic;
	uses generic_acl;
	uses meta_vtable;	

    function_sql attach_onbefore_method
    {
      params '(text,text,text,text,text,text)';
      returns int;
      
      S
      %%
      @ "
      DECLARE
        __method_area ALIAS FOR \$1;
	__method_class ALIAS FOR \$2;
	__method_name ALIAS FOR \$3;
	__area ALIAS FOR \$4;
	__class ALIAS FOR \$5;
	__method ALIAS FOR \$6;
        __h_id int;

      BEGIN
        SELECT id INTO __h_id FROM co_${name_area}_meta_class
	WHERE class_name = __method_class AND area = __method_area;
	update co_${name_area}_meta_method
	set id_onbefore_method =
	(SELECT id FROM co_${name_area}_meta_method
	 WHERE id_meta_class = __h_id AND method_name = __method_name)
	WHERE
	id_meta_class = (SELECT id FROM co_${name_area}_meta_class
	WHERE class_name = __class AND area = __area)
	AND method_name = __method
	;
	
	RETURN 1;
      END;
      "
      %%
      ;
    };

    function_sql attach_onafter_method
    {
      params '(text,text,text,text,text,text)';
      returns int;
      
      S
      %%
      @ "
      DECLARE
        __method_area ALIAS FOR \$1;
	__method_class ALIAS FOR \$2;
	__method_name ALIAS FOR \$3;
	__area ALIAS FOR \$4;
	__class ALIAS FOR \$5;
	__method ALIAS FOR \$6;
        __h_id int;

      BEGIN
        SELECT id INTO __h_id FROM co_${name_area}_meta_class
	WHERE class_name = __method_class AND area = __method_area;
	update co_${name_area}_meta_method
	set id_onafter_method =
	(SELECT id FROM co_${name_area}_meta_method
	 WHERE id_meta_class = __h_id AND method_name = __method_name)
	WHERE
	id_meta_class = (SELECT id FROM co_${name_area}_meta_class
	WHERE class_name = __class AND area = __area)
	AND method_name = __method
	;
	
	RETURN 1;
      END;
      "
      %%
      ;
    };

	method commitChange
	{
		doc "This method commits all changes done on this method to database. Now works only for new method."
		{
			pl "Ta metoda wprowadza wszystkie zrobione na tej metodzie zmiany do bazy danych. Obecnie wprowadza tylko now metod.";
		};

		id_permission __PERMISSION_UPDATE;
		sec_type __METHOD_SEC_TYPE_OBJECT;
   
		__PARAMS_HEADER
     
		declare language_c
		{
			C 'char * state;';
			C 'char * method_name;';
			C 'char * class_name;';
			C 'int id_class;';
			C 'co_array_of_pointers * get_class_names    = coa_Create(cnx);';
			C 'co_array_of_pointers * get_prop_names     = coa_Create(cnx);';
			C 'co_array_of_pointers * filter_class_names = coa_Create(cnx);';
			C 'co_array_of_pointers * filter_prop_names  = coa_Create(cnx);';
			C 'co_array_of_pointers * filter_operators   = coa_Create(cnx);';
			C 'co_array_of_pointers * filter_values      = coa_Create(cnx);';
			C 'co_array_of_pointers * create_params      = coa_Create(cnx);';
			C 'int NTuples = 0;';
			C 'int NProps = 0;';
			C 'int i = 0;';
			C 'int id_permission;';
			C 'int sec_type;';
			C 'int force_sec_type;';
		};
 
		body language_c
		{
			C 
			%%
			// reading state
			@co_call(par_area, par_class, "get", par_area=>par_area, par_class=>par_class, par_id=>par_id);
			__GET_RETURNED_RECORDSET(corec)
			state 			= cor_GetCopyOfValueByName(cnx, corec, 0, "state");
			method_name 	= cor_GetCopyOfValueByName(cnx, corec, 0, "method_name");
			class_name 		= cor_GetCopyOfValueByName(cnx, corec, 0, "class_name");
			id_permission 	= atoi(cor_GetValueByName(cnx, corec, 0, "id_permission"));
			sec_type 		= atoi(cor_GetValueByName(cnx, corec, 0, "sec_type"));
			force_sec_type 	= atoi(cor_GetValueByName(cnx, corec, 0, "force_sec_type"));

			__SEND_MESG_DEBUG("	state = %s, method_name = %s, class_name = %s, id_permission = %d, sec_type = %d, force_sec_type = %d",
				state, method_name, class_name, id_permission, sec_type, force_sec_type)

			// this is new method
			if(strcmp(state, "NEW")==0)
			{
				//changing state to INSYNC
				@co_call(par_area, par_class, "update", par_area=>par_area, par_class=>par_class, par_id=>par_id, par_prop=>'"state"', new_value=>'"INSYNC"', version=>-1);

				@co_call(par_area, '"meta_vtable"', "updateTarget", par_area=>par_area, par_class=>par_class, par_id=>-1, class_name=>class_name, method_name=>method_name, target_class=>class_name, id_permission=>id_permission, sec_type=>sec_type, force_sec_type=>force_sec_type);
	
			}
			%%
			; 
		};  

	}; // method commitChange


};  
