#include "types.t"      
#include "defines.t"      

// CLASS

class scriptfan
{ 
  area "sys";
  
  inherits generic_acl;

#include "check_acl.t"
  
  container_class '';
  container_column_name '';
      
 // PROPERTIES
      
#include "generic_acl_props.t"      

  prop my_data
  {      
    type CO_STRING;      
    default "''";      
    params 'ROWS=20;COLS=60';      
    representant 100;      
    foreign '';      
    foreign_prop '';      
    position 200;    
  };    

// METHODS

  method showData
  {
     doc
     %%
		This is test of method implemented in JavaScript.
		See: README
     %%
     ;
       
     id_permission __PERMISSION_GET;
     sec_type __METHOD_SEC_TYPE_OBJECT;

     __PARAMS_HEADER
     
     body language_javascript
     {
        C
        %%
var par_id = Params.getParam("par_id");
var par_class = Params.getParam("par_class");
var par_area = Params.getParam("par_area");

var my_class = new class_scriptfan(par_area);
var data = my_class.getProp( par_id, 'my_data');
ap_write(data);
        %%
      ;
    };      
  };

  method getData
  {
     doc
     %%
		This is test of method implemented in JavaScript.
		Data is returned to the caller as string.
		See: README
     %%
     ;
       
     id_permission __PERMISSION_GET;
     sec_type __METHOD_SEC_TYPE_OBJECT;

     __PARAMS_HEADER
     
     body language_javascript
     {
        C
        %%
var par_id = Params.getParam("par_id");
var par_class = Params.getParam("par_class");
var par_area = Params.getParam("par_area");

var my_class = new class_scriptfan(par_area);
var data = my_class.getProp( par_id, 'my_data');
return data;
        %%
      ;
    };      
  };

  method  setData
  {
     doc
     %%
		This is test of method implemented in JavaScript
     %%
     ;
       
     id_permission __PERMISSION_UPDATE;
     sec_type __METHOD_SEC_TYPE_OBJECT;
 
     __PARAMS_HEADER
     
     param data {type CO_STRING;};
 
     body language_javascript
     {
        C
        %%
var par_id = Params.getParam("par_id");
var par_class = Params.getParam("par_class");
var par_area = Params.getParam("par_area");
var data = Params.getParam("data");

var my_class = new class_scriptfan(par_area);
my_class.update(par_id, -1, 'my_data', data);

ap_write("updated!");
        %%
      ;
    };      
  };

};

//END OF CLASS CATALOG
