/* this will be mod_co_spreadsheet_row */

#include "httpd.h"

/* PostgreSQL access functions */
#include "libpq-fe.h"
#include <stdlib.h>
#include <unistd.h>

#include "../../include/co_lib.h"
#include "../../include/co_convutils.h"
#include "../../include/co_defines.h"

static void
exit_nicely(PGconn *conn)
{
}

__CO_METHOD(co_create)

 __GET_INTEGER(par_id)
 __GET_INTEGER(rowBefore_id)
 __GET_INTEGER(rowAfter_id)
 int rowToInsert_num,rowInserted_id;

 __INIT_VARIABLES
 
 if (rowBefore_id)
 {
  // calculate rowToInsert_num
  sprintf(SQLString,"SELECT row_number FROM co_sys_spreadsheet_rows WHERE id=%d",rowBefore_id);
  __SQL_GET_RESULT
  rowToInsert_num = atoi(PQgetvalue(res,0,0));
  PQclear(res);
 }
 else
 {
  //calculate rowToInsert_num
  sprintf(SQLString,"SELECT row_number FROM co_sys_spreadsheet_rows WHERE id=%d",rowAfter_id);
  __SQL_GET_RESULT
  rowToInsert_num = atoi(PQgetvalue(res,0,0))+1;
  PQclear(res);
 }

 // shift after-rows
 sprintf(SQLString,"UPDATE co_sys_spreadsheet_rows SET");
 sprintf(SQLString,"%s row_number=row_number+1 WHERE",SQLString);
 sprintf(SQLString,"%s row_number>=%d AND spreadsheet_id=%d",SQLString,rowToInsert_num,par_id);
 __SQL_EXEC
 // now insert row
 sprintf(SQLString,"INSERT INTO co_sys_spreadsheet_rows(row_number,spreadsheet_id)");
 sprintf(SQLString,"%s VALUES(%d,%d)",SQLString,rowToInsert_num,par_id);
 __SQL_EXEC

 if (cnx->putJS)
 {
  // generate javascript for client
  
  // calculate rowInserted_id
  sprintf(SQLString,"SELECT id FROM co_sys_spreadsheet_rows WHERE");
  sprintf(SQLString,"%s row_number=%d AND spreadsheet_id=%d",SQLString,rowToInsert_num,par_id);
  __SQL_GET_RESULT
  rowInserted_id = atoi(PQgetvalue(res,0,0));
  PQclear(res);
  // put javascript
  sprintf(JSOutBuf,"c_s();\nclient_addRow(%d,%d);\n",rowInserted_id,rowToInsert_num);
  cou_putJS(cnx,JSOutBuf);
 }
 return 0;
}

__CO_METHOD(co_delete)

 __GET_INTEGER(par_id)
 __GET_INTEGER(row_id)

 int row_num;

 sprintf(SQLString,"SELECT row_number FROM co_sys_spreadsheet_rows WHERE id=%d",row_id);
 __SQL_GET_RESULT
 row_num = atoi(PQgetvalue(res,0,0));
 PQclear(res);

 sprintf(SQLString,"DELETE FROM co_sys_spreadsheet_rows WHERE id=%d",row_id);
 __SQL_EXEC

 sprintf(SQLString,"UPDATE co_sys_spreadsheet_rows SET row_number=row_number-1");
 sprintf(SQLString,"%s WHERE row_number>%d AND spreadsheet_id=%d",SQLString,row_num,par_id);
 __SQL_EXEC

 sprintf(SQLString,"DELETE FROM co_sys_spreadsheet_cells WHERE row_id=%d",row_id);
 __SQL_EXEC

 if (cnx->putJS)
 {
  sprintf(JSOutBuf,"c_s();\ndelete_row(%d);\nrbutton_onclick(0);\n",row_num);
  cou_putJS(cnx,JSOutBuf);
 }

 //ap_rputs("...wilkommen aus spreadsheet_column",r);
 return 0;
}

__CO_METHOD(co_hello)

 ap_rputs("...wilkommen aus spreadsheet_row",r);
 return 0;
}